# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .key_indicators_item_additional_kpis_item import KeyIndicatorsItemAdditionalKpisItem
from .key_indicators_item_extra_kpis_item import KeyIndicatorsItemExtraKpisItem


class KeyIndicatorsItem(pydantic_v1.BaseModel):
    key: str = pydantic_v1.Field()
    """
    The key for this KPI, where you can find the value from inside main_kpi
    """

    title: str = pydantic_v1.Field()
    """
    The title for this metric, to be displayed to the user
    """

    main_kpi: str
    secondary_kpi: typing.Optional[str] = None
    additional_kpis: typing.Optional[typing.List[KeyIndicatorsItemAdditionalKpisItem]] = pydantic_v1.Field(default=None)
    """
    Additional KPIs to be displayed at the bottom of the box
    """

    extra_kpis: typing.Optional[typing.List[KeyIndicatorsItemExtraKpisItem]] = pydantic_v1.Field(default=None)
    """
    Extra KPIs to be displayed in the hover-tootip for that indicator
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
